# justin.deal

A personal website featuring a blog, project portfolio, and homelab dashboard.

## About

This site serves as my digital home on the web, built with modern web technologies and a focus on performance, accessibility, and user experience.

- **Visit**: [https://justin.deal](https://justin.deal)
- **Built with**: Astro, TypeScript, TailwindCSS, and Alpine.js

## Key Features

### Content
- Blog with searchable posts and tag filtering
- Project portfolio with detailed case studies
- Homelab dashboard for self-hosted services
- Dark/light mode with Gruvbox-inspired theme

### Technical
- Component-based architecture
- Responsive design for all devices
- Advanced search with keyboard navigation
- Optimized loading with skeleton states
- Accessibility-first approach

## Quick Start

```bash
# Install dependencies
pnpm install

# Development server
pnpm dev

# Production build
pnpm build
```

## Adding Content

- **Blog**: Create markdown files in `src/pages/blog/`
- **Projects**: Add project details in `src/pages/projects/`
- **Homelab**: Update services in `src/pages/homelab/services.ts`

## License

MIT
